<?php
/*
 * Plugin Name: CoolIris-Piclens
 * Version: 0.2.0
 * Description: Cooliris/Piclens activation
 * Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=234
 * Author: Tiico
 * Author URI: 
 * */
 /* 0.2.0 --> version for PIWIGO 2.0.0    */

define('PHPWG_ROOT_PATH','../../');
include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
include(PHPWG_ROOT_PATH.'include/section_init.inc.php');

//tiico
//include(PHPWG_ROOT_PATH.'include/functions_category.inc.php');

$py_addext = array("gvideo", "dm", "ytube", "wideo");



// +-----------------------------------------------------------------------+
// | Check Access and exit when user status is not ok                      |
// +-----------------------------------------------------------------------+
check_status(ACCESS_GUEST);

set_make_full_url();

$obj = new Piclens();
$obj->load_config();

// Vrification prsence et activation plugins SecureImages ET si actif, vrification d'activation de compatibilit
$plugins_SecureImage = (get_db_plugins('active','secureImages') ? ($obj->my_config['piclens_secureimage'] ? 1 : 0 ) : 0);

//echo "plugins_SecureImage=".$plugins_SecureImage;
// Vrification d'activation du plugin (page administration)
if ($obj->my_config['piclens_active'])
{

	$thumb_secure = array('', '&amp;thumb=1', '');	// correspondant a 1-->'miniature' et 2-->'normal'
	$normal_secure = array('', '&amp;thumb=1', '', '&amp;highdef=1');	// correspondant a 1-->'miniature' et 2-->'normal' et 3 --> High
	$order_list = array('', $conf['order_by'], 'ORDER BY date_creation', 'ORDER BY date_available', 'ORDER BY average_rate', 'ORDER BY hit', 'ORDER BY file', 'ORDER BY id', '');	
	$order_sort = array('', '', ' ASC', ' DESC');


	
$type_ext = $obj->my_config['included_file_types'];
foreach($type_ext as $i => $value)
$type_ext[$i] = '"'.$value.'"';

//-------------------------------------------------------------- initialization

	// Seulement sur une page type 'categorie'
	if (($page['section']) == 'categories')
	{
	$cat = array();
	$picturesID = array();

	$pictures = array();
			
		
		// Page accueil
	    if(empty($page['category'])) 
	    {
			// Page accueil

		// Vrification d'activation du plugin (page administration)
		if ($obj->my_config['piclens_gallerie_active'])
		{
			
			
    			$query = 'SELECT id,name,permalink FROM ' . CATEGORIES_TABLE
			.' WHERE id_uppercat is NULL';
			$result = pwg_query($query);
			while ($row = mysql_fetch_assoc($result))
			{
				if (!(in_array($row[id], explode(',', $user['forbidden_categories']))))
				{
					array_push($cat, $row[id]);
				}
			}
			// Type = avec recursiite
			if (( $obj->my_config['piclens_gallerie_type'])-1)
			{
				// rcupration des sous-catgories (tous niveaux) de la catgorie en cours.
				$subcat= get_subcat_ids($cat);
	
				// Vrification droits des sous-categories
				foreach($subcat as $sscat)
				{
					if (!(in_array($sscat, explode(',', $user['forbidden_categories']))))
						array_push($cat, $sscat);
				}
			}
			$query1 = 'SELECT image_id FROM ' . IMAGE_CATEGORY_TABLE
				.' WHERE category_id IN ('.implode(',', $cat).')'
				.';';
			$result1 = pwg_query($query1);

			while ($row = mysql_fetch_assoc($result1))
				array_push($picturesID, $row[image_id]);

			$query = 'SELECT * FROM ' . IMAGES_TABLE
		 	.' WHERE id IN ('.implode(',', $picturesID).')'
			.(sizeof($obj->my_config['included_file_types']) ? ' AND tn_ext IN ('.implode(',', $type_ext).')' : '')
	// Choix du critre de tri d'affichage
			.$order_list[ $obj->my_config['piclens_order'] ]
			.$order_sort[ $obj->my_config['piclens_sort'] ];

		}

	    }
	
	
	// access authorization check
	elseif (isset($page['category']))
	{
	  check_restrictions($page['category']['id']);


		// Si rcursivit active 
		if ($obj->my_config['piclens_recursive'])
		{
	// tiico: recherche de toutes les photos de la categorie (incluant les photos des sous-categories si necessaire)
		$selectionID = $page['category']['id'];
		array_push($cat, $selectionID);


			// rcupration des sous-catgories (tous niveaux) de la catgorie en cours.
			$subcat= get_subcat_ids(array($selectionID));

			// Vrification droits des sous-categories
			foreach($subcat as $sscat)
	 		{
				if (!(in_array($sscat, explode(',', $user['forbidden_categories']))))
					array_push($cat, $sscat);
			}

			


			$query1 = 'SELECT image_id FROM ' . IMAGE_CATEGORY_TABLE
				.' WHERE category_id IN ('.implode(',', $cat).')'
				.';';
			$result1 = pwg_query($query1);

			while ($row = mysql_fetch_assoc($result1))
			{
				array_push($picturesID, $row[image_id]);
			}
			$query = 'SELECT * FROM ' . IMAGES_TABLE
		 	.' WHERE id IN ('.implode(',', $picturesID).')'
			.(sizeof($obj->my_config['included_file_types']) ? ' AND tn_ext IN ('.implode(',', $type_ext).')' : '')
	// 	. $conf['order_by'].';';
	// Choix du critre de tri d'affichage
			.$order_list[ $obj->my_config['piclens_order'] ]
			.$order_sort[ $obj->my_config['piclens_sort'] ];

		}// Fin rcursivit
		else
		{
			$selection = $page['items'];
			$query = 'SELECT * FROM ' . IMAGES_TABLE
			.' WHERE id IN ('.implode(',', $selection).')'
			.(sizeof($obj->my_config['included_file_types']) ? ' AND tn_ext IN ('.implode(',', $type_ext).')' : '')
	// 	. $conf['order_by'].';';
	// Choix du critre de tri d'affichage
			.$order_list[ $obj->my_config['piclens_order'] ]
			.$order_sort[ $obj->my_config['piclens_sort'] ];
			
		}
	// tiico

	}

	 
	$result = pwg_query($query);
	
	while ($row = mysql_fetch_assoc($result))
	{
		array_push($pictures, $row);
	}
	


	// It's a rss file
	header("Content-Type: application/xml; charset=UTF-8");
	echo '<?xml version="1.0" encoding="utf-8" standalone="yes"?>';
	 

	?>

	        <rss version="2.0" 
	          xmlns:media="http://search.yahoo.com/mrss"
	          xmlns:atom="http://www.w3.org/2005/Atom">
	<channel>

	<?php

	
	$o=0;
	// For each picture
	foreach ($pictures as $row)
	{
		$piclens_normal = $obj->my_config['piclens_normal'];

		// si parametrage high et high absente ou utilisateur non habilit, affichage version normale
		if (($piclens_normal == 3) && (!($row['has_high']) || !$user['enabled_high']))
			$piclens_normal = 2; // Normal uniquement pour l'image en cours

		// Get thumbnail url
		if ($plugins_SecureImage)	// SecureImage installe et actif
		{
			$link_url = $page['root_path'].'plugins/secureImages/getFile.php?image_id='.$row['id'];

			$thumbnail_url = get_root_url().'plugins/secureImages/getFile.php?image_id='.$row['id']
			.$thumb_secure[$obj->my_config['piclens_thumb'] ];
			$content_url = $page['root_path'].'plugins/secureImages/getFile.php?image_id='.$row['id']
			.$normal_secure[$piclens_normal ];
		}
		else	// SecureImage non installe ou non actif
		{
			$link_url = $page['root_path'].$row['path'];
			
			if ( ($obj->my_config['piclens_thumb']) == 2) 	// Normal
				$thumbnail_url = (url_is_remote($row['path']) ? $row['path']: $page['root_path'].$row['path']);
			else
				$thumbnail_url = get_thumbnail_url($row);


				switch ($piclens_normal)
			{
			case 1 : // miniature
				$content_url = get_thumbnail_url($row);
				break;
			case 2 : // normal
				$content_url = (url_is_remote($row['path']) ? $row['path']: $page['root_path'].$row['path']);
				break;
			case 3 : 
				 $content_url = $page['root_path']. dirname($row['path']).'/pwg_high/'.basename($row['path']);

				 break;
				$content_url = (url_is_remote($row['path']) ? $row['path']: $page['root_path'].$row['path']);
			default : // normal
				break;
			}
			//$content_url = $page['root_path'].$row['path'];
		}
		
		// link on picture.php page
		$url = duplicate_picture_url(
			array(
				'image_id' => $row['id'],
				'image_file' => $row['file']
			),
			array('start')
		);
		
		// Show rss item for a picture
		echo "<item>\n";
		echo "<title>" . get_thumbnail_title($row) . "</title>\n";

		// Description (nom de vignette) prsent
		if (isset($row['name']))
			echo '<media:description>'.$row['name'].' </media:description>';
				
		// link
		echo "<link>" . $url . "</link>\n";

		echo "<guid>" . $row['id'] . "</guid>\n";
		
		echo "<media:thumbnail url=\"" . $thumbnail_url . "\" />\n";

		$extension = explode(".", $row['file']); 
		$extension = $extension[sizeof($extension)-1];
//		echo "ext=".$extension[sizeof($extension)-1];
		if ((in_array($extension, $py_addext))) // Fichiers video
		{
		
			$idvideo = file_get_contents($page['root_path'].$row['path']);
			$sp = explode("/", $idvideo);
			switch ($extension)
			{
				case "dm" :
					echo "<enclosure url=\"http://www.dailymotion.com/swf/".$sp[0]."\" type=\"application/x-shockwave-flash\"/>";
					break;
				case "ytube":
					echo "<enclosure url=\"http://youtube.com/v/".$sp[0].".swf\" type=\"application/x-shockwave-flash\"/>";
					break;
				case "wideo":
					echo "<enclosure url=\"http://www.kewego.com/swf/p3/epix.swf?language_code=fr&amp;playerKey=0df9b773a15b&amp;skinKey=7109c4112f57&amp;sig=".$sp[0]."\" type=\"application/x-shockwave-flash\"/>";
					break;
				case "gvideo":
					echo "<enclosure url=\"http://video.google.com/googleplayer.swf?docid=".$sp[0]."\" type=\"application/x-shockwave-flash\"/>";
					break;
			}
		}
		else
			echo "<media:content url=\"" . $content_url . "\" />\n";

		echo "</item>\n";
		echo "\n";
	}
	}
	
}

?>
</channel>
</rss>